#!/usr/bin/python
# coding: UTF-8
#グロー効果( http://torigont.blog58.fc2.com/blog-entry-114.html , http://dic.pixiv.net/a/%E3%82%B0%E3%83%AD%E3%83%BC%E5%8A%B9%E6%9E%9C )をスクリプトにしてみた


from gimpfu import *

def glow_default(img, draw,low_level,br):
	lay=pdb.gimp_image_get_active_layer(img)
	lay1=pdb.gimp_layer_copy(lay,FALSE)
	pdb.gimp_image_insert_layer(img,lay1,None,-1)
	lay1.name='glow effect default'

	# 色→レベルで低レベル値を増やし、白に近い色を黒くする
	pdb.gimp_levels(lay1,HISTOGRAM_VALUE,low_level,255,1,0,255)

	pdb.plug_in_gauss(img,lay1,br,br,1) # RLE=1, ガウンシアンぼかし
	pdb.gimp_layer_set_mode(lay1,SCREEN_MODE) # レイヤーモードをスクリーン

	pdb.gimp_image_set_active_layer(img,lay)


def glow_omake(img, draw,low_level,br,opacity):
	lay=pdb.gimp_image_get_active_layer(img)
	lay1=pdb.gimp_layer_copy(lay,FALSE)
	pdb.gimp_image_insert_layer(img,lay1,None,-1)
	lay1.name='glow effect omake'

	# 色→レベルで入力の低レベル値を増やし、白に近い色を黒くする
	pdb.gimp_levels(lay1,HISTOGRAM_VALUE,low_level,255,1,0,255)

	pdb.plug_in_gauss(img,lay1,br,br,1) # RLE=1, ガウンシアンぼかし
	pdb.gimp_layer_set_mode(lay1,BURN_MODE) # レイヤーモードを焼き込み
	pdb.gimp_layer_set_opacity(lay1,opacity) # 不透明度を下げる

	pdb.gimp_image_set_active_layer(img,lay)


def glow(img, draw,type,low_level,br,opacity):
	pdb.gimp_undo_push_group_start(img)
	if type==0:
		glow_default(img, draw,low_level,br)
	else:
		glow_omake(img,draw,low_level,br,opacity)
	pdb.gimp_undo_push_group_end(img)


register(
        "python_fu_glow_effect",
        "グロー効果(Type:DefaultはLayer Opacityを使わない。OmakeはLowest Color Levelを低くしないと暗い。)",
        "グロー効果",
        "amekujira",
        "amekujira",
        "2015",
        "<Image>/Filters/Blur/グロー効果",
        "RGB*, GRAY*",
        [
      (PF_RADIO, "type", "Type:", 0, (("Default",0), ("Omake",1)) ),
      (PF_SPINNER, "low_level", "Lowest Color Level", 140, (0, 255, 1)),
      (PF_SPINNER, "br", "Gaussian Blur Radius", 30, (0, 500, 1)),
      (PF_SPINNER, "opacity", "Layer Opacity", 40, (0, 100, 1)),
	],
        [],
        glow)

main()
