﻿#!/usr/bin/python
# coding: UTF-8
#画像間で可視レイヤーをまとめてコピー


from gimpfu import *

def copy(img, draw, dest_img, newImage):
 if newImage:
  dest_img = pdb.gimp_image_new(img.width, img.height, 0) #新画像はRGB固定
  disp = pdb.gimp_display_new(dest_img)

 for l in img.layers[::-1]: #逆順リスト
  if l.visible:
   cp_lay = pdb.gimp_layer_new_from_drawable(l, dest_img)
   cp_lay.name=l.name #名前の後ろにコピーを付けない
   dest_img.add_layer(cp_lay)

register(
        "python_fu_copy_visible_layers",
        "画像間で可視レイヤーをまとめてコピー",
        "copy layers between images",
        "amekujira",
        "amekujira",
        "2015",
        "<Image>/Layer/画像間で可視レイヤーをまとめてコピー",
        "*",
        [
      (PF_IMAGE, "dest_img", "移動先 Image", None),
      (PF_BOOL,   "newImage", "新画像を作成", False),
	],
        [],
        copy)

main()
